#ifndef __DIZHEN_H__
#define __DIZHEN_H__

#include "GLApp.h"
#include "DynastyView.h"

#define kDiTool_None		-1
#define kDiTool_Mesh		0
#define kDiTool_Tile		1
#define kDiTool_Point		2
#define kDiNumTools			3

typedef struct DiDocument DiDocument;
typedef struct DiTool DiTool;

DiDocument *DiNewDocument(GLint x, GLint y, GLint w, GLint h);
void DiDocumentParseEvent(GLAppPanel *panel, GLAppPanel *gen, GLuint type, GLuint key);

void DiMeshToolSelect(DiDocument *doc);
void DiMeshToolDeselect(DiDocument *doc);
void DiTileToolSelect(DiDocument *doc);
void DiTileToolDeselect(DiDocument *doc);
void DiPointToolSelect(DiDocument *doc);
void DiPointToolDeselect(DiDocument *doc);

struct DiTool {
	GLAppPanel *button;
	GLAppPanel *sidebar;
	
	void (*Select)(DiDocument *);
	void (*Deselect)(DiDocument *);
};

struct DiDocument {
	GLAppPanel *panel;
	GLAppPanel *view;
	DiTool *tools[kDiNumTools];
	DynWorld *world;
	GLint tool;
};

#endif
