#ifndef __GLASS_H__
#define __GLASS_H__

#include "GLApp.h"

typedef struct DynViewData DynViewData;
typedef struct DynWorld DynWorld;
typedef struct DynMesh DynMesh;
typedef struct DynTile DynTile;

DynWorld *DynNewWorld(GLfloat lightx, GLfloat lighty, GLfloat lightz);
DynMesh *DynAddMesh(DynWorld *world, GLfloat x, GLfloat y, GLfloat z, GLfloat xsize,
	GLfloat ysize, GLint xres, GLint yres);

GLAppPanel *DynNewView(GLint x, GLint y, GLint w, GLint h, DynWorld *world, GLfloat xpos,
	GLfloat zpos, GLfloat yaw, GLfloat pitch, GLfloat zoom, GLboolean wire, GLboolean points);
void DynViewRedrawContents(GLAppPanel *panel);
void DynCalcNormal(DynTile *tile);

struct DynViewData {
	DynWorld *world;
	GLfloat viewx, viewz;
	GLfloat yaw, pitch;
	GLfloat zoom;
	GLint viewport[4];
	GLboolean wire, points;
	GLint projectionList, modelviewList;
};

struct DynWorld {
	DynMesh *meshes;
	
	GLfloat light[3];
};

struct DynMesh {
	GLfloat x, y, z;
	GLfloat xsize, ysize;
	GLint xres, yres;
	GLboolean updated;
	GLint mainlist, wirelist, pointlist;
	GLfloat *heights;
	DynTile *tiles;
	DynMesh *next;
};

struct DynTile {
	GLfloat norm1[3], norm2[3];
	GLfloat color[3];
	GLint x, y;
	GLboolean altdivide;
	DynMesh *mesh;
};

#endif
